# Tables

This page lists all tables on the pol.fusion contract, including their descriptions and a breakdown of each datapoint stored in the table.

## Quick Links

[#config2](#config2 "mention")

[#delegated\_bandwidth](#delegated_bandwidth "mention")

[#pools\_struct](#pools_struct "mention")

[#refund\_request](#refund_request "mention")

[#renters](#renters "mention")

[#state3](#state3 "mention")

[#top21](#top21 "mention")

### config2

> The config singleton stores the percentage of revenue that should be allocated to Alcor liquidity, and the long term CPU rental pool.

| Column                        | Type      | Description                                                                                |
| ----------------------------- | --------- | ------------------------------------------------------------------------------------------ |
| liquidity\_allocation\_1e6    | uint64\_t | The 1e6 scaled percentage of POL revenue that should be used to provide liquidity on Alcor |
| rental\_pool\_allocation\_1e6 | uint64\_t | The 1e6 scaled percentage of POL revenue that should be moved into the CPU rental pool     |
| lswax\_wax\_pool\_id          | uint64\_t | The pool ID of the LSWAX/WAX liquidity pool on Alcor                                       |

### delegated\_bandwidth

> The delegated bandwidth table is stored on the eosio system contract, and is referenced in our smart contracts so it can be accessed for managing CPU rentals.

### pools\_struct

> The pools struct is located on Alcor's swap.alcor contract, and is referenced in our contract so we can automate the process of managing the protocol's liquidity position on Alcor.

### refund\_request

> The refund request table is located on the eosio system contract, and is referenced in our contract so that we can claim refunds after we unstake WAX from wallets who rented CPU.

### renters

> The renters table is used for keeping track of wallets who have active CPU rentals through WaxFusion's long term rental system.&#x20;

| Column            | Type      | Description                                                                         |
| ----------------- | --------- | ----------------------------------------------------------------------------------- |
| ID                | uint64\_t | A unique ID to identify the row. It uses available\_primary\_key                    |
| renter            | name      | The WAX address that paid for the CPU rental                                        |
| rent\_to\_account | name      | The WAX address that receives the CPU from the renter                               |
| amount\_staked    | asset     | The amount of WAX that is currently staked to the rent\_to\_account for this rental |
| expires           | uint64\_t | The epoch timestamp that the rental will be considered expired                      |

### state3

> The state3 singleton keeps track of the current global state of this contract

| Column                          | Type      | Description                                                                                         |
| ------------------------------- | --------- | --------------------------------------------------------------------------------------------------- |
| wax\_available\_for\_rentals    | asset     | The amount of WAX that is currently available for people to rent CPU                                |
| next\_day\_end\_time            | uint64\_t | The epoch timestamp that the current "full day" ends (used for timing CPU rentals)                  |
| cost\_to\_rent\_1\_wax          | asset     | The WAX price that users will pay to rent 1 WAX for 1 full day                                      |
| last\_vote\_time                | uint64\_t | The epoch timestamp of the last time this contract has refreshed its vote for block producers       |
| wax\_bucket                     | asset     | The amount of WAX currently waiting to be allocated to protocol owned liquidity on Alcor            |
| lswax\_bucket                   | asset     | The amount of lsWAX currently waiting to be allocated to protocol owned liquidity on Alcor          |
| last\_liquidity\_addition\_time | uint64\_t | The epoch timestamp of the last time funds were added to the protocol's liquidity position on Alcor |
| wax\_allocated\_to\_rentals     | asset     | The amount of WAX currently being staked to users via long term CPU rental                          |
| pending\_refunds                | asset     | The amount of WAX that is in the refunding process on the system contract                           |
| last\_rebalance\_time           | uint64\_t | The timestamp of the last time the rebalance action was successfully called on this contract        |

### top21

> The top21 singleton keeps track of which block producers are in the top 21 on the system contract

| Column           | Type          | Description                                                   |
| ---------------- | ------------- | ------------------------------------------------------------- |
| block\_producers | vector\<name> | A list of the top 21 block producers as of the last update    |
| last\_update     | uint64\_t     | The epoch timestamp of the last time this table was refreshed |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.waxfusion.io/smart-contracts/pol.fusion/tables.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
